/*
 * Copyright (C) 2007-2023 Xagasoft, All rights reserved.
 *
 * This file is part of the libbu++ library and is released under the
 * terms of the license contained in the file LICENSE.
 */

#ifndef BU_TEE_STREAM_H
#define BU_TEE_STREAM_H

#include "bu/filter.h"

namespace Bu
{
    class TeeStream : public Bu::Stream
    {
    public:
        TeeStream();
        virtual ~TeeStream();

        void addStream( Bu::Stream &rStream );

        virtual void close();
        virtual Bu::size tell();
        virtual void seek( Bu::size offset );
        virtual void setPos( Bu::size pos );
        virtual void setPosEnd( Bu::size pos );
        virtual bool isEos();
        virtual bool isOpen();

        virtual void flush();

        virtual bool canRead();
        virtual bool canWrite();

        virtual bool isReadable();
        virtual bool isWritable();
        virtual bool isSeekable();

        virtual bool isBlocking();
        virtual void setBlocking( bool bBlocking=true );

        /**
         * Most filters won't re-implement this, it doesn't make a lot of sense
         * for filters, in general.
         */
        virtual void setSize( Bu::size iSize );

        virtual size getSize() const;
        virtual size getBlockSize() const;
        virtual Bu::String getLocation() const;

    private:
        class StreamWrapper
        {
        public:
            StreamWrapper( Bu::Stream &r ) : rStream( r ) { }
            Bu::Stream &rStream;
        };
        typedef Bu::List<StreamWrapper> StreamRefList;
        StreamRefList lStream;
    };
}

#endif
